# exchange the directory below with the directory in which data are stored

setwd("c:/muscles/data")

# reading in data:

R.inverse.women.group1<-as.matrix(read.table("R.inverse.women.group1.txt",sep=","))
R.inverse.women.group2<-as.matrix(read.table("R.inverse.women.group2.txt",sep=","))
R.inverse.women.group3<-as.matrix(read.table("R.inverse.women.group3.txt",sep=","))
R.inverse.men.group1<-as.matrix(read.table("R.inverse.men.group1.txt",sep=","))
R.inverse.men.group2<-as.matrix(read.table("R.inverse.men.group2.txt",sep=","))
R.inverse.men.group3<-as.matrix(read.table("R.inverse.men.group3.txt",sep=","))

Lambda.women.group1<-as.matrix(read.table("Lambda.women.group1.txt",sep=","))
Lambda.women.group2<-as.matrix(read.table("Lambda.women.group2.txt",sep=","))
Lambda.women.group3<-as.matrix(read.table("Lambda.women.group3.txt",sep=","))
Lambda.men.group1<-as.matrix(read.table("Lambda.men.group1.txt",sep=","))
Lambda.men.group2<-as.matrix(read.table("Lambda.men.group2.txt",sep=","))
Lambda.men.group3<-as.matrix(read.table("Lambda.men.group3.txt",sep=","))


coefficients.women.group1<-as.matrix(read.table("coefficients.women.group1.txt",sep=","))
coefficients.women.group2<-as.matrix(read.table("coefficients.women.group2.txt",sep=","))
coefficients.women.group3<-as.matrix(read.table("coefficients.women.group3.txt",sep=","))
coefficients.men.group1<-as.matrix(read.table("coefficients.men.group1.txt",sep=","))
coefficients.men.group2<-as.matrix(read.table("coefficients.men.group2.txt",sep=","))
coefficients.men.group3<-as.matrix(read.table("coefficients.men.group3.txt",sep=","))




# muscle index functions:



# First argument is measurements on data types 
# C076, C077, C088, C089, C100, C101, C112, C113,
# C316, C317, C328, C329, C340, C341, C352, C353, 
# C356, C357, C368, C369, C380, C381, C392, C393, 
# C396, C397, C408, C409, C420, C421, C432, C433.
# If no measurement is performed, a 0 is entered.

# Second argument is covariates age, weight and height

muscleindex.women.group1<-function(x,v){
v<-c(1,v)
v[2]<-max(v[2]-41,0)
X.temp<-t(coefficients.women.group1[,!x==0])%*%v
lambda.inv.temp<-solve(Lambda.women.group1[!x==0,!x==0])
index.temp<-((117-length(x[!x==0]))/(117*length(x[!x==0])*(1+t(v)%*%R.inverse.women.group1%*%v)))*
            (t(x[!x==0]-t(coefficients.women.group1[,!x==0])%*%v)%*%lambda.inv.temp)%*%
            (x[!x==0]-t(coefficients.women.group1[,!x==0])%*%v)
p.temp<-round(1-pf(length(x[!x==0]),118-length(x[!x==0]),index.temp),digits=4)
weak<-1*p.temp<0.05*(sum(x-X.temp)<0)
strong<-1*p.temp<0.05*(sum(x-X.temp)>0)
index.temp<-round(index.temp,digits=2)
p.temp<-ifelse(p.temp==0,"p < 0.0001",paste("p = ",p.temp))
index.temp<-ifelse(index.temp==0,"index < 0.01",paste("Index = ",index.temp))
switch(1+weak+2*strong,paste("NORMAL. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("WEAK. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("STRONG. ",index.temp,". p-value for normality: ",p.temp,"."))
}


# First argument is measurements on data types 
# C116,C117,C128,C129,C140,C141,C152,C153.
# If no measurement is performed, a 0 is entered.

# Second argument is covariates age, weight and height


muscleindex.women.group2<-function(x,v){
v<-c(1,v)
v[2]<-max(v[2]-27,0)
X.temp<-t(coefficients.women.group2[,!x==0])%*%v
lambda.inv.temp<-solve(Lambda.women.group2[!x==0,!x==0])
index.temp<-((117-length(x[!x==0]))/(118*length(x[!x==0])*(1+t(v)%*%R.inverse.women.group2%*%v)))*
            (t(x[!x==0]-t(coefficients.women.group2[,!x==0])%*%v)%*%lambda.inv.temp)%*%
            (x[!x==0]-t(coefficients.women.group2[,!x==0])%*%v)
p.temp<-round(1-pf(length(x[!x==0]),118-length(x[!x==0]),index.temp),digits=4)
weak<-1*p.temp<0.05*(sum(x-X.temp)<0)
strong<-1*p.temp<0.05*(sum(x-X.temp)>0)
index.temp<-round(index.temp,digits=2)
p.temp<-ifelse(p.temp==0,"p < 0.0001",paste("p = ",p.temp))
index.temp<-ifelse(index.temp==0,"index < 0.01",paste("Index = ",index.temp))
switch(1+weak+2*strong,paste("NORMAL. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("WEAK. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("STRONG. ",index.temp,". p-value for normality: ",p.temp,"."))
}



# First argument is measurements on data types 
# C156,C157,C168,C169,C180,C181,C192,C193,
# C196,C197,C208,C209,C220,C221,C232,C233,
# C236,C237,C248,C249,C260,C261,C272,C273,
# C276,C277,C288,C289,C300,C301,C312,C313,C436,C437,C448,C449,
# C460,C461,C472,C473
# If no measurement is performed, a 0 is entered.

# Second argument is covariates age, weight and height


muscleindex.women.group3<-function(x,v){
v<-c(1,v[1:2])
v[2]<-max(v[2]-44,0)
X.temp<-t(coefficients.women.group3[,!x==0])%*%v
lambda.inv.temp<-solve(Lambda.women.group3[!x==0,!x==0])
index.temp<-((118-length(x[!x==0]))/(117*length(x[!x==0])*(1+t(v)%*%R.inverse.women.group3%*%v)))*
            (t(x[!x==0]-t(coefficients.women.group3[,!x==0])%*%v)%*%lambda.inv.temp)%*%
            (x[!x==0]-t(coefficients.women.group3[,!x==0])%*%v)
p.temp<-round(1-pf(length(x[!x==0]),119-length(x[!x==0]),index.temp),digits=4)
weak<-1*p.temp<0.05*(sum(x-X.temp)<0)
strong<-1*p.temp<0.05*(sum(x-X.temp)>0)
index.temp<-round(index.temp,digits=2)
p.temp<-ifelse(p.temp==0,"p < 0.0001",paste("p = ",p.temp))
index.temp<-ifelse(index.temp==0,"index < 0.01",paste("Index = ",index.temp))
switch(1+weak+2*strong,paste("NORMAL. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("WEAK. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("STRONG. ",index.temp,". p-value for normality: ",p.temp,"."))
}



# First argument is measurements on data types 
# C076, C077, C088, C089, C100, C101, C112, C113,
# C316, C317, C328, C329, C340, C341, C352, C353, 
# C356, C357, C368, C369, C380, C381, C392, C393, 
# C396, C397, C408, C409, C420, C421, C432, C433.
# If no measurement is performed, a 0 is entered.

# Second argument is covariates age, weight and height

muscleindex.men.group1<-function(x,v){
v<-c(1,v[1])
X.temp<-t(coefficients.men.group1[,!x==0])%*%v
lambda.inv.temp<-solve(Lambda.men.group1[!x==0,!x==0])
index.temp<-((52-length(x[!x==0]))/(52*length(x[!x==0])*(1+t(v)%*%R.inverse.men.group1%*%v)))*
            (t(x[!x==0]-t(coefficients.men.group1[,!x==0])%*%v)%*%lambda.inv.temp)%*%
            (x[!x==0]-t(coefficients.men.group1[,!x==0])%*%v)
p.temp<-round(1-pf(length(x[!x==0]),53-length(x[!x==0]),index.temp),digits=4)
weak<-1*p.temp<0.05*(sum(x-X.temp)<0)
strong<-1*p.temp<0.05*(sum(x-X.temp)>0)
index.temp<-round(index.temp,digits=2)
p.temp<-ifelse(p.temp==0,"p < 0.0001",paste("p = ",p.temp))
index.temp<-ifelse(index.temp==0,"index < 0.01",paste("Index = ",index.temp))
switch(1+weak+2*strong,paste("NORMAL. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("WEAK. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("STRONG. ",index.temp,". p-value for normality: ",p.temp,"."))
}


# First argument is measurements on data types 
# C116,C117,C128,C129,C140,C141,C152,C153.
# If no measurement is performed, a 0 is entered.

# Second argument is covariates age, weight and height

muscleindex.men.group2<-function(x,v){
v<-c(1,v[c(1,3)])
v[2]<-max(v[2]-43,0)
X.temp<-t(coefficients.men.group2[,!x==0])%*%v
lambda.inv.temp<-solve(Lambda.men.group2[!x==0,!x==0])
index.temp<-((52-length(x[!x==0]))/(52*length(x[!x==0])*(1+t(v)%*%R.inverse.men.group2%*%v)))*
            (t(x[!x==0]-t(coefficients.men.group2[,!x==0])%*%v)%*%lambda.inv.temp)%*%
            (x[!x==0]-t(coefficients.men.group2[,!x==0])%*%v)
p.temp<-round(1-pf(length(x[!x==0]),53-length(x[!x==0]),index.temp),digits=4)
weak<-1*p.temp<0.05*(sum(x-X.temp)<0)
strong<-1*p.temp<0.05*(sum(x-X.temp)>0)
index.temp<-round(index.temp,digits=2)
p.temp<-ifelse(p.temp==0,"p < 0.0001",paste("p = ",p.temp))
index.temp<-ifelse(index.temp==0,"index < 0.01",paste("Index = ",index.temp))
switch(1+weak+2*strong,paste("NORMAL. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("WEAK. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("STRONG. ",index.temp,". p-value for normality: ",p.temp,"."))
}


# First argument is measurements on data types 
# C156,C157,C168,C169,C180,C181,C192,C193,
# C196,C197,C208,C209,C220,C221,C232,C233,
# C236,C237,C248,C249,C260,C261,C272,C273,
# C276,C277,C288,C289,C300,C301,C312,C313,C436,C437,C448,C449,
# C460,C461,C472,C473
# If no measurement is performed, a 0 is entered.

# Second argument is covariates age, weight and height

muscleindex.men.group3<-function(x,v){
v<-c(1,v[1])
v[2]<-max(v[2]-27,0)
X.temp<-t(coefficients.men.group3[,!x==0])%*%v
lambda.inv.temp<-solve(Lambda.men.group3[!x==0,!x==0])
index.temp<-((52-length(x[!x==0]))/(52*length(x[!x==0])*(1+t(v)%*%R.inverse.men.group3%*%v)))*
            (t(x[!x==0]-t(coefficients.men.group3[,!x==0])%*%v)%*%lambda.inv.temp)%*%
            (x[!x==0]-t(coefficients.men.group3[,!x==0])%*%v)
p.temp<-round(1-pf(length(x[!x==0]),53-length(x[!x==0]),index.temp),digits=4)
weak<-1*p.temp<0.05*(sum(x-X.temp)<0)
strong<-1*p.temp<0.05*(sum(x-X.temp)>0)
index.temp<-round(index.temp,digits=2)
p.temp<-ifelse(p.temp==0,"p < 0.0001",paste("p = ",p.temp))
index.temp<-ifelse(index.temp==0,"index < 0.01",paste("Index = ",index.temp))
switch(1+weak+2*strong,paste("NORMAL. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("WEAK. ",index.temp,". p-value for normality: ",p.temp,"."),
              paste("STRONG. ",index.temp,". p-value for normality: ",p.temp,"."))
}






